#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdDebug(int condescriptor, const char *arg);


int CmdDebug(int condescriptor, const char *arg)
{
	int con_obj_num;
	char	*s,
		num_str[80],
		sndbuf[CS_DATA_MAX_LEN],
		text[256];
	xsw_object_struct *con_obj;
	sws_connection_struct *con = connection[condescriptor];

	/* Get connection's object number (assumed valid). */
	con_obj_num = con->object_num;
	con_obj = xsw_object[con_obj_num];

	/* Print usage? */
	if((arg != NULL) ? (*arg == '\0') : 1)
	{
	    sprintf(
		sndbuf,
 "debug level: %i  debug value: %.6f",
		debug.level, debug.val
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);

	    NetSendLiveMessage(
		condescriptor,
 "Usage: debug <level>[=value]"
	    );

	    NetSendLiveMessage(
		condescriptor,
 "<levels> can be: DEBUG_LEVEL_NONE = 0, DEBUG_LEVEL_ALL = 1"
	    );

	    NetSendLiveMessage(
		condescriptor,
 "DEBUG_LEVEL_MEMORY = 2, DEBUG_LEVEL_NETWORK = 3"
	    );

	    return(0);
	}

	/* Only root can set debug. */
	if(con_obj->permission.uid > 0)
	{
	    sprintf(
		sndbuf,
		"Permission denied: Access level %i required.",
		0
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	    return(-1);
	}


	/* Parse debug value argument. */
	s = strchr(arg, '=');
	if(s != NULL)
	{
	    s++;
	    while(ISBLANK(*s))
		s++;

	    debug.val = atof(s);
	}

	/* Parse debug level. */
	strncpy(num_str, arg, 80);
	num_str[80 - 1] = '\0';

	s = strchr(num_str, '=');
	if(s != NULL)
	    *s = '\0';

	s = num_str;
	while(ISBLANK(*s))
	    s++;

	debug.level = atoi(s);


	sprintf(
	    text,
	    "debug: level %i: value %.4f",
	    debug.level, debug.val
	);
	NetSendLiveMessage(condescriptor, text);


	return(0);
}
