#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"
 
 
/*
 *      Check user ID and group ID of object.
 */
int CmdID(int condescriptor, const char *arg)
{
	int con_obj_num, obj_num;
	char sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *obj, *con_obj;
	sws_connection_struct *con = connection[condescriptor];

	/* Get connection's object number (assumed valid) */
	con_obj_num = con->object_num;
	con_obj = xsw_object[con_obj_num];

	if((arg == NULL) ? 1 : (*arg == '\0'))
	{
	    if(!DBIsObjectGarbage(con_obj->locked_on))
		obj_num = con_obj->locked_on;
	    else
		obj_num = con_obj_num;
	}
	else if(!strcasecmp(arg, "me"))
	{
	    obj_num = con_obj_num;
	}
	else
	{
	    obj_num = MatchObjectByName(
		xsw_object, total_objects,
		arg, SW_OBJ_TYPE_PLAYER
	    );
	}
	if(DBIsObjectGarbage(obj_num))
	{
	    sprintf(
		sndbuf,
		"%s: No such player.",
		arg
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	    return(-1);
	}

	obj = xsw_object[obj_num];

	/* Print ID */
	sprintf(
	    sndbuf,
	    "%s: uid: %i  gid: %i",
	    DBGetFormalNameStr(obj_num),
	    obj->permission.uid,
	    obj->permission.gid
	);
	NetSendLiveMessage(condescriptor, sndbuf);

	return(0);
}
