#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdSaveUniverse(int condescriptor, const char *arg);


#define THIS_CMD_NAME	"save"


/*
 *	Saves the universe.
 */
int CmdSaveUniverse(int condescriptor, const char *arg)
{
	int con_obj_num;
        char sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[condescriptor];

	/* Get connection's object number (assumed valid) */
	con_obj_num = con->object_num;
	obj = xsw_object[con_obj_num];

	/* Permission check */
	if(obj->permission.uid > SWS_ACCESS_UID_SAVE)
	{
	    sprintf(
		sndbuf,
		"%s: Permission denied: Requires access level %i.",
		THIS_CMD_NAME, SWS_ACCESS_UID_SAVE
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	    return(-1);
	}

	/* Log */
	if(sysparm.log_general)
	{
	    char text[SW_OBJ_NAME_MAX + 512];
	    sprintf(
		text,
"%s: Requesting database save.",
		DBGetFormalNameStr(con_obj_num)
	    );
	    LogAppend(fname.log, text);
	}

	/* Do save procedure */
	SWServSaveUnv();

	/* Schedual next universe save */
	next.unv_save = cur_systime + sysparm.int_unv_save;

	return(0);
}
