#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdScore(int condescriptor, const char *arg);


#define THIS_CMD_NAME	"score"


int CmdScore(int condescriptor, const char *arg)
{
	int con_obj_num, obj_num;
	xsw_object_struct *obj, *con_obj;
	xsw_score_struct *score;
	sws_connection_struct *con = connection[condescriptor];
	char sndbuf[CS_DATA_MAX_LEN]; 

	con_obj_num = con->object_num;
	con_obj = xsw_object[con_obj_num];

	/* Parse object number */
	if((arg != NULL) ? (*arg == '\0') : 1)
	{
	    if(con_obj->locked_on > -1)
		obj_num = con_obj->locked_on;
	    else
		obj_num = con_obj_num;
	}
	else if(!strcasecmp(arg, "me"))
	{
	    obj_num = con_obj_num;
	}
	else
	{
	    obj_num = MatchObjectByName(
		xsw_object, total_objects,
		arg, -1
	    );
	}
	if(DBIsObjectGarbage(obj_num))
	{
	    sprintf(
		sndbuf,
		"%s: No such object.",
		arg
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	    return(-1);
	}

	obj = xsw_object[obj_num];
	score = obj->score;
	if(score != NULL)
	{
	    sprintf(
		sndbuf,
"%s: Credits: %.2f  RMU: %.2f(%.2f)  DmgGiv: %.2f  DmgRec: %.2f\
  Kills: %i",
		DBGetFormalNameStr(obj_num),
		score->credits,
		score->rmu,
		score->rmu_max,
		score->damage_given,
		score->damage_recieved,
		score->kills
	    );
	}
	else
	{  
	    sprintf(sndbuf, "%s: No scores.", obj->name);
	}
	NetSendLiveMessage(condescriptor, sndbuf);

	return(0);
}
