#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


#define THIS_CMD_NAME	"synctime"


/*
 *	Syncs timmings.
 */
int CmdSyncTime(int condescriptor, const char *arg)
{
	int con_obj_num;
	char sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *con_obj;
	sws_connection_struct *con = connection[condescriptor];

	/* Get connection's object number (assumed valid) */
	con_obj_num = con->object_num;
	con_obj = xsw_object[con_obj_num];

	/* Check if object's permission allows sync time */
	if(con_obj->permission.uid > SWS_ACCESS_UID_SYNCTIME)
	{
	    sprintf(
		sndbuf,
		"%s: Permission denied: Requires access level %i.",
		THIS_CMD_NAME,
		SWS_ACCESS_UID_SYNCTIME
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	    return(-1);
	}

	/* Log */
	if(sysparm.log_general)
	{
	    char text[SW_OBJ_NAME_MAX + 256];
	    sprintf(
		text,
"%s: Syncronized timmers.",
		DBGetFormalNameStr(con_obj_num)
	    );
	    LogAppend(fname.log, text);
	}

	/* Warn all connections about timming reset */
	NetSendLiveMessage(-1, "Server: Syncronizing timmers...");

	/* Reset all timmers */
	SWServResetTimmers(cur_millitime, cur_systime);

	/* Warn all connections about timming reset */
	NetSendLiveMessage(-1, "Server: Timmers syncronized.");

	return(0);
}
