#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int CmdWall(int condescriptor, const char *arg);


/*
 *	Prints message to all connections.
 */
int CmdWall(int condescriptor, const char *arg)
{
	int con_obj_num;
	xsw_object_struct *con_obj;
	sws_connection_struct *con;
	char mesg[CS_MESG_MAX];
	char sndbuf[CS_DATA_MAX_LEN];


	/* Get connection's object number (assumed valid) */
	con = connection[condescriptor];
	con_obj_num = con->object_num;
	con_obj = xsw_object[con_obj_num];

	/* No argument given? */
	if((arg != NULL) ? (*arg == '\0') : 1)
	    return(-1);

	/* Copy argument to local message buffer */
	strncpy(mesg, arg, sizeof(mesg));
	mesg[sizeof(mesg) - 1] = '\0';
	strstrip(mesg);

	/* Format and send message to all connections */
	sprintf(
	    sndbuf,
	    "<%s>: \"%s\"",
	    con_obj->name,
	    mesg
	);
	NetSendLiveMessage(-1, sndbuf);

	return(0);
}
