#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"

#include "net.h"
#include "swserv.h"


int CmdWho(int condescriptor, const char *arg);


#define THIS_CMD_NAME	"who"

#define SPACES		"                                           "


int CmdWho(int condescriptor, const char *arg)
{
	char	num_str[40],
		sndbuf[CS_DATA_MAX_LEN + 128];

	/* Use default argument if NULL */
	if(arg == NULL)
	    arg = "";

	/* Skip leading spaces */
	while(*arg == ' ')
	    arg++;

	/* Print all connections? */
	if(*arg == '\0')
	{
	    int i, obj_num, players_connected = 0;
	    char *s;
	    xsw_object_struct *obj;
	    sws_connection_struct *con;  

	    for(i = 0; i < total_connections; i++)
	    {
		con = connection[i];
		if(con == NULL)
		    continue;

		if(con->socket < 0)
		    continue;

		obj_num = con->object_num;
		if(DBIsObjectGarbage(obj_num))
		    continue;

		obj = xsw_object[obj_num];

		/* Player Name */
		s = sndbuf;
		*s = '\0';
		strcat(s, DBGetFormalNameStr(obj_num));
		strcat(s, SPACES);

		/* Empire */
		s = sndbuf + 24;
		*s = '\0';
		strcat(s, obj->empire);
		strcat(s, SPACES);

		/* Client Type Code */
		s = sndbuf + 34;
		*s = '\0'; 
		sprintf(num_str, "%i", con->client_type);
		strcat(s, num_str);
		strcat(s, SPACES);

		/* Connected Time */
		s = sndbuf + 44;
		*s = '\0';
		strcat(s, StringFormatTimePeriod(cur_systime - con->contime));
		strcat(s, SPACES);

		/* Is Guest */
		if(con->flags & CON_FLAG_IS_GUEST)
		{
		    s = sndbuf + 68;
		    *s = '\0';
		    strcat(s, "Guest");
		}

		NetSendLiveMessage(condescriptor, sndbuf);

		players_connected++;
	    }

	    /* Print footer */
	    sprintf(
		sndbuf,
		"*** %i player%s connected. ***",
		players_connected,
		(players_connected == 1) ? "" : "s"
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	}
	/* Print all connections with host names */   
	else if(!strcasecmp(arg, "*"))
	{
	    int i, obj_num, players_connected = 0;
	    char *s;
	    xsw_object_struct *obj;
	    sws_connection_struct *con;

	    for(i = 0; i < total_connections; i++)
	    {
		con = connection[i];
		if(con == NULL)
		    continue;

		if(con->socket < 0)
		    continue;

		obj_num = con->object_num;
		if(DBIsObjectGarbage(obj_num))
		    continue;

		obj = xsw_object[obj_num];

		/* Player Name */
		s = sndbuf;
		*s = '\0';
		strcat(s, DBGetFormalNameStr(obj_num));
		strcat(s, SPACES);

		/* Empire */
		s = sndbuf + 24;
		*s = '\0';
		strcat(s, obj->empire);
		strcat(s, SPACES);

		/* Client Type Code */
		s = sndbuf + 34;
		*s = '\0';
		sprintf(num_str, "%i", con->client_type);
		strcat(s, num_str);
		strcat(s, SPACES);

		/* Host */
		s = sndbuf + 44;
		*s = '\0';
		strcat(s, con->conhost);
		strcat(s, SPACES);

		/* Is Guest */
		if(con->flags & CON_FLAG_IS_GUEST)
		{
		    s = sndbuf + 68;
		    *s = '\0';
		    strcat(s, "Guest");
		}
		NetSendLiveMessage(condescriptor, sndbuf);

		players_connected++;
	    }

	    /* Print footer */
	    sprintf(
		sndbuf,
		"*** %i player%s connected. ***",
		players_connected,
		(players_connected == 1) ? "" : "s"
	    );
	    NetSendLiveMessage(condescriptor, sndbuf);
	}
	/* Print specific player */
	else
	{
	    int	con_num,
		obj_num = MatchObjectByName(
		    xsw_object, total_objects,
		    arg, SW_OBJ_TYPE_PLAYER
		);
	    if(DBIsObjectGarbage(obj_num))
	    {               
		sprintf(
		    sndbuf,
		    "%s: %s: No such player.",
		    THIS_CMD_NAME,
		    arg
		);
		NetSendLiveMessage(condescriptor, sndbuf);   
		return(-1);
	    }

	    /* Get first connection that references the object */
	    con_num = ConGetByObject(obj_num);
	    if(con_num > -1)
	    {
		char *s;
		xsw_object_struct *obj = xsw_object[obj_num];
		sws_connection_struct *con = connection[con_num];

		/* Player Name */
		s = sndbuf;
		*s = '\0';
		strcat(s, DBGetFormalNameStr(obj_num));
		strcat(s, SPACES);

		/* Empire */
		s = sndbuf + 24;
		*s = '\0';
		strcat(s, obj->empire);
		strcat(s, SPACES);

		/* Client Type Code */
		s = sndbuf + 34;
		*s = '\0';
		sprintf(num_str, "%i", con->client_type);
		strcat(s, num_str);
		strcat(s, SPACES);

		/* Connected Time */
		s = sndbuf + 44;
		*s = '\0';
		strcat(s, StringFormatTimePeriod(cur_systime - con->contime));
		strcat(s, SPACES);

		/* Is Guest */
		if(con->flags & CON_FLAG_IS_GUEST)
		{
		    s = sndbuf + 68;
		    *s = '\0';
		    strcat(s, "Guest");
		}

		NetSendLiveMessage(condescriptor, sndbuf);
	    }
	    else
	    {
		sprintf(
		    sndbuf,
		    "%s: %s: Not connected.",
		    THIS_CMD_NAME,
		    arg
		);
		NetSendLiveMessage(condescriptor, sndbuf);
		return(-1);
	    }
	}

	return(0);
}
