#include <stdio.h>
#include <stdlib.h>

#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleAutoDestruct(int condescriptor, char *arg);
int NetSendAutoDestruct(int condescriptor, int obj_num);


int NetHandleAutoDestruct(int condescriptor, char *arg)
{
	int obj_num;
	unsigned long sec;
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[condescriptor];

	/* SWEXTCMD_AUTODESTRUCT format:
	 *
	 *	obj_num sec
	 */
	sscanf(
	    arg,
	    "%i %lu",
	    &obj_num, &sec
	);
	if(DBIsObjectGarbage(obj_num) ||
	   (con->object_num != obj_num)
	)
	    return(-1);

	/* Schedual or cancel auto-destruct on the object */
	obj = xsw_object[obj_num];
	if(sec > 0l)
	    obj->auto_destruct_next = cur_systime + (time_t)sec;
	else
	    obj->auto_destruct_next = 0l;

	/* Send response to connection of auto destruct start or
	 * cancel
	 */
	NetSendAutoDestruct(condescriptor, obj_num);

#if 0
/* Client will print message when it receives the response by
 * NetSendAutoDestruct()
 */
	/* Notify connection of auto-destruct start or cancel */
	if(sec > 0l)
	    sprintf(
		text,
"Auto-destruct in %lu seconds...",
		sec
	    );
	else
	    strcpy(text, "Auto-destruct canceled.");
	NetSendLiveMessage(condescriptor, text);
#endif

	return(0);
}

int NetSendAutoDestruct(int condescriptor, int obj_num)
{
	unsigned long sec;
	char sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];

	if(obj->auto_destruct_next > 0l)
	    sec = (unsigned long)(
		obj->auto_destruct_next - cur_systime
	    );
	else
	    sec = 0l;

	/* SWEXTCMD_AUTODESTRUCT format:
	 *             
	 *	obj_num sec
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %lu\n",
	    CS_CODE_EXT,
	    SWEXTCMD_AUTODESTRUCT,
	    obj_num, sec
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
