#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"

#include "net.h"
#include "swserv.h"


int NetHandleSetCloak(int condescriptor, char *arg)
{
	int obj_num, con_obj_num;
        int cloak_state;
        xsw_object_struct *obj;
	sws_connection_struct *con = connection[condescriptor];

        con_obj_num = con->object_num;
        if(DBIsObjectGarbage(con_obj_num))
            return(-1);

	obj = xsw_object[con_obj_num];

        /* SWEXTCMD_SETCLOAK format:
         *
         *	obj_num cloak_state
         */
        sscanf(
	    arg,
	    "%i %i",
            &obj_num, &cloak_state
        );      

        /* Connection must own object */
        if(obj_num != con_obj_num)
            return(-3);

        /* Does object have cloak abilities? */
        if(obj->cloak_state == CLOAK_STATE_NONE)
            return(-3);

        /* Are shields up? if so, lower it */
        if(obj->shield_state == SHIELD_STATE_UP)
            obj->shield_state = SHIELD_STATE_DOWN;

        /* Raise cloak? */
        if((obj->cloak_state == CLOAK_STATE_DOWN) &&
           (cloak_state == CLOAK_STATE_UP)
        )
        {
	    /* Can only cloak if there is antimatter */
	    if(obj->antimatter > 0.0)
		obj->cloak_state = CLOAK_STATE_UP;
        }
        /* Lower cloak? */
        else if((obj->cloak_state == CLOAK_STATE_UP) &&
                (cloak_state == CLOAK_STATE_DOWN)
        )
        {  
            obj->cloak_state = CLOAK_STATE_DOWN;
        }


        /* Set next object values update to now so it gets updated now */
        next.object_values = cur_millitime;


        return(0);
}


int NetSendSetCloak(int condescriptor)
{
        return(0);
}
