#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleSetDmgCtl(int condescriptor, char *arg)
{
	int obj_num, con_obj_num;
	int damage_control;
	xsw_object_struct *obj;

	con_obj_num = connection[condescriptor]->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return(-1);

	obj = xsw_object[con_obj_num];

	/* SWEXTCMD_SETDMGCTL format:
	 *
	 *	obj_num, damage_control
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &damage_control
	);

	/* Connection must own object */
	if(obj_num != con_obj_num)
	    return(-3);


	/* Turn damage control on? */   
	if((obj->damage_control == DMGCTL_STATE_OFF) &&
	   (damage_control == DMGCTL_STATE_ON)
	)
	{
	    obj->damage_control = DMGCTL_STATE_ON;
	}
	/* Turn damage control off? */
	else if((obj->damage_control == DMGCTL_STATE_ON) &&
		(damage_control == DMGCTL_STATE_OFF)
	)
	{   
	    obj->damage_control = DMGCTL_STATE_OFF;
	}


	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_millitime;


	return(0);
}


int NetSendSetDmgCtl(int condescriptor)
{
	return(0);
}
