#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "swserv.h"
#include "net.h"


int NetSendELinkFoward(int condescriptor, char *url);
int NetHandleELinkEnter(int condescriptor, char *arg);


int NetSendELinkFoward(int condescriptor, char *url)
{
	char sndbuf[CS_DATA_MAX_LEN];

	if(url == NULL)
	    return(-1);

	/* CS_CODE_FORWARD forward:
	 *
	 *	url
	 */
	sprintf(
	    sndbuf,
"%i %s\n",
	    CS_CODE_FORWARD,
	    url
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}

int NetHandleELinkEnter(int condescriptor, char *arg)
{
	int src_obj_num, tar_obj_num;
	xsw_object_struct *tar_obj;

	/* SWEXTCMD_ELINKENTER format:
	 *
	 *	src_obj_num tar_obj_num
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &src_obj_num, &tar_obj_num
	);

	if(DBIsObjectGarbage(tar_obj_num))
	    return(-1);

	tar_obj = xsw_object[tar_obj_num];

	/* Check if object is a elink */
	if(tar_obj->type != SW_OBJ_TYPE_ELINK)
	    return(-2);

	/* Set forward to url */
	NetSendELinkFoward(condescriptor, tar_obj->elink);

	return(0);
}
