#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleSetImageSet(int condescriptor, char *arg);
int NetHandleSetSoundSet(int condescriptor, char *arg);
int NetHandleSetOCSN(int condescriptor, char *arg);

int NetSendSetImageSet(int condescriptor, const char *filename);
int NetSendSetSoundSet(int condescriptor, const char *filename);
int NetSendSetOCSN(int condescriptor, const char *filename);


int NetHandleSetImageSet(int condescriptor, char *arg)
{
	NetSendSetImageSet(condescriptor, unv_head.imgrefs);
	return(0);
}

int NetHandleSetSoundSet(int condescriptor, char *arg)
{
	NetSendSetSoundSet(condescriptor, unv_head.sndrefs);
        return(0);
}

int NetHandleSetOCSN(int condescriptor, char *arg)
{
	NetSendSetOCSN(condescriptor, unv_head.ocsn);
        return(0);
}


int NetSendSetImageSet(int condescriptor, const char *filename)
{
	char	lname[CS_DATA_MAX_LEN - 20],
		sndbuf[CS_DATA_MAX_LEN];

	if(filename == NULL)
	    return(-1);
	if(*filename == '\0')
	    return(-1);

	strncpy(lname, filename, sizeof(lname));
	lname[sizeof(lname) - 1] = '\0';

	/* Format CS_CODE_IMAGESET:
	 *
	 *	path
	 */
	sprintf(
	    sndbuf,
	    "%i %s\n",
	    CS_CODE_IMAGESET,
	    lname
	);
	NetDoSend(condescriptor, sndbuf);

        return(0);
}

int NetSendSetSoundSet(int condescriptor, const char *filename)
{
        char	lname[CS_DATA_MAX_LEN - 20],
		sndbuf[CS_DATA_MAX_LEN];

        if(filename == NULL)
            return(-1);
        if(*filename == '\0')
            return(-1);

        strncpy(lname, filename, sizeof(lname));
        lname[sizeof(lname) - 1] = '\0';

        /* Format CS_CODE_SOUNDSET:
         *
         *	path
         */
        sprintf(
	    sndbuf,
	    "%i %s\n",
	    CS_CODE_SOUNDSET,
	    lname
        );
        NetDoSend(condescriptor, sndbuf);

        return(0);
}

int NetSendSetOCSN(int condescriptor, const char *filename)
{
        char	lname[CS_DATA_MAX_LEN - 30],
		sndbuf[CS_DATA_MAX_LEN];

        if(filename == NULL)
            return(-1);
        if(*filename == '\0')
            return(-1);

        strncpy(lname, filename, sizeof(lname));
        lname[sizeof(lname) - 1] = '\0';

        /* Format SWEXTCMD_SETOCSN:
         *
         *	path
         */
        sprintf(
	    sndbuf,
	    "%i %i %s\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETOCSN,
	    lname
        );
        NetDoSend(condescriptor, sndbuf);

        return(0);
}
