#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleSetInterval(int condescriptor, char *arg)
{
	long interval;
	sws_connection_struct *con = connection[condescriptor];

	if(!ConIsLoggedIn(condescriptor))
	    return(-1);

	if(*arg == '\0')
	    return(-1);

	/* NET_CMD_SETINTERVAL format:
	 *      
	 *	interval
	 */
	sscanf(
	    arg,
	    "%ld",
	    &interval
	);

	/* Clip interval */
	if(interval < SWS_MIN_OBJECT_UPDATE_INT)
	    interval = SWS_MIN_OBJECT_UPDATE_INT;
	else if(interval > SWS_MAX_OBJECT_UPDATE_INT)
	    interval = SWS_MAX_OBJECT_UPDATE_INT;

	/* Set new update interval */
	con->obj_ud_interval = interval;

	return(0);
}


int NetSendSetInterval(int condescriptor)
{
	return(0);
}
