#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleSetIntercept(int condescriptor, char *arg)
{
	int obj_num;
	char	*s,
		larg[CS_DATA_MAX_LEN],
		intercept_arg[SW_OBJ_NAME_MAX];
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[condescriptor];

	strncpy(larg, arg, sizeof(larg));
	larg[sizeof(larg) - 1] = '\0';

        /* NET_CMD_INTERCEPT format:
         *
         *      obj_num argument
         */

	/* Get intercept argument first */
	s = strchr(larg, ' ');
	if(s != NULL)
	{
	    *s = '\0';
	    s++;

	    while(*s == ' ')
		s++;

	    strncpy(intercept_arg, s, sizeof(intercept_arg));
	    intercept_arg[sizeof(intercept_arg) - 1] = '\0';
	}
	else
	{
	    *intercept_arg = '\0';
	}

	/* Get other arguments */
	sscanf(
	    larg,
"%i",
	    &obj_num
	);

	if(obj_num != con->object_num)
	    return(-1);

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];

	/* Turn off intercept? */
	if((*intercept_arg == '\0') ||
           !strcasecmp(intercept_arg, "#off")
	)
	{
	    obj->intercepting_object = -1;
	}
	/* Intercept locked on object? */
	else if(strcasepfx(intercept_arg, "#l"))
	{
	    obj->intercepting_object = obj->locked_on;
	}
	else
	{
	    /* Match intercepting object */
	    obj->intercepting_object = UNVMatchIntercept(
		xsw_object, total_objects,
		obj_num, intercept_arg
	    );
	    if(obj->intercepting_object < 0)
	    {
		s = (char *)malloc(strlen(intercept_arg) + 80);
		sprintf(
		    s,
"Unable to find object `%s' to intercept.",
		    intercept_arg
		);
		NetSendLiveMessage(condescriptor, s);
		free(s);
	    }
	}

	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_millitime;

	return(0);
}


int NetSendSetIntercept(int condescriptor)
{
	return(0);
}
