#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleLighting(int condescriptor, char *arg)
{
	int obj_num, con_obj_num;
	unsigned long lighting;		/* sw_flags_t */
	xsw_object_struct *obj;
	sws_connection_struct *con = connection[condescriptor];

	con_obj_num = con->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return(-1);

	obj = xsw_object[con_obj_num];

	/* SWEXTCMD_SETLIGHTING format:
	 *
	 *	obj_num lighting
	 */
	sscanf(
	    arg,
	    "%i %ld",
	    &obj_num, &lighting   
	);

	/* Only allow setting of the connection's object */
	if(obj_num != con_obj_num)
	    return(-3);

	/* Set lighting */
	obj->lighting = (sw_flags_t)lighting;

	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_millitime;

	return(0);
}


int NetSendLighting(int condescriptor)
{
	return(0);
}
