#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/string.h"
#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "sysparm.h"
#include "swserv.h"


int NetHandleLogout(int condescriptor);


#define ATOI(s)		(((s) != NULL) ? atoi(s) : 0)
#define ATOL(s)		(((s) != NULL) ? atol(s) : 0)
#define ATOF(s)		(((s) != NULL) ? atof(s) : 0.0f)
#define STRDUP(s)	(((s) != NULL) ? strdup(s) : NULL)

#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define MIN(a,b)	(((a) < (b)) ? (a) : (b))
#define CLIP(a,l,h)	(MIN(MAX((a),(l)),(h)))
#define STRLEN(s)	(((s) != NULL) ? strlen(s) : 0)
#define STRISEMPTY(s)	(((s) != NULL) ? (*(s) == '\0') : 1)
	

int NetHandleLogout(int condescriptor)
{
	int obj_num;
	sws_connection_struct *con;

	/* Net connected? */
	if(!ConIsConnected(condescriptor))
	    return(-1);

	con = connection[condescriptor];
	obj_num = con->object_num;
	if(DBIsObjectGarbage(obj_num))
	{
	    /* Never logged in */
	}
	else
	{
	    /* Send normal leave message to connection */
	    xsw_object_struct *obj = xsw_object[obj_num];
	    char	*s = STRDUP(sysparm.mesg_leave),
			*s2 = strsub(s, "%title", unv_head.title),
			*mesg;
	    free(s);
	    mesg = strsub(s2, "%name", obj->name);
	    free(s2);
	    NetSendLiveMessage(condescriptor, mesg);
	    free(mesg);
	}

	/* Send logout to connection and close connection */
	NetCloseConnection(condescriptor);

	return(0);
}


int NetSendLogout(int condescriptor)
{
	char sndbuf[CS_DATA_MAX_LEN];

	/* CS_CODE_LOGOUT format:
	 *
	 */
	sprintf(
	    sndbuf,
	    "%i\n",
	    CS_CODE_LOGOUT
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
