#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleNotifyHit(int condescriptor, char *arg);
int NetSendNotifyHit(
        int condescriptor,
        int wep_obj_num, int tar_obj_num,
        double total_damage,
        double bearing,			/* Target to weapon, in radians */
        double structure_damage,
        double shield_damage
);


int NetHandleNotifyHit(int condescriptor, char *arg)
{
	return(0);
}


int NetSendNotifyHit(
	int condescriptor,
	int wep_obj_num, int tar_obj_num,
	double total_damage,
	double bearing,			/* Target to weapon, in radians */
	double structure_damage,
	double shield_damage
)
{
	char sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *tar_obj;

	if(DBIsObjectGarbage(tar_obj_num))
	    return(-1);

	tar_obj = xsw_object[tar_obj_num];

	/* SWEXTCMD_NOTIFYHIT format:
	 *
	 *	wep_obj_num tar_obj_num
	 *	total_damage bearing
	 *	structure_damage shield_damage
	 *	hp power
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i\
 %.4f %.4f\
 %.4f %.4f\
 %.4f %.4f\n",
	    CS_CODE_EXT,
	    SWEXTCMD_NOTIFYHIT,
	    wep_obj_num, tar_obj_num,
	    total_damage, bearing,
	    structure_damage, shield_damage,
	    tar_obj->hp, tar_obj->power
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);   
}
