#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleCreateObject(int condescriptor, char *arg)
{
	return(0);
}


int NetSendCreateObject(int condescriptor, int obj_num)
{
	char sndbuf[CS_DATA_MAX_LEN];
	xsw_animation_struct *anim;
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];
	anim = &obj->animation;

	/* CS_CODE_CREATEOBJ format:
	 *
	 *	obj_num
	 *	type imgref_num owner size
	 *	locked_on intercepting_object scanner_range
	 *	sect_x sect_y sect_z
	 *	x y z
	 *	heading pitch bank
	 *	velocity
	 *	velocity_heading velocity_pitch velocity_bank
	 *	current_frame anim_int total_frames cycle_times
	 *	lifespan
	 *
	 *	27 args
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i %i %ld\
 %i %i %.4f\
 %ld %ld %ld\
 %.4f %.4f %.4f\
 %.4f %.4f %.4f\
 %.4f\
 %.4f %.4f %.4f\
 %i %ld %i %i\
 %ld\n",
	    CS_CODE_CREATEOBJ,
	    obj_num,
	    obj->type, obj->imageset, obj->owner, obj->size,
	    obj->locked_on, obj->intercepting_object, obj->scanner_range,
	    obj->sect_x, obj->sect_y, obj->sect_z,
	    obj->x, obj->y, obj->z,
	    obj->heading, obj->pitch, obj->bank,
	    obj->velocity,
	    obj->velocity_heading, 0.0 * PI, 0.0 * PI,
	    anim->current_frame,
	    anim->interval,
	    anim->total_frames,
	    anim->cycle_times,
	    obj->lifespan
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
