#include <stdio.h>
#include <string.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleObjectDescription(int condescriptor, char *arg)
{
	int obj_num;

	/* SWEXTCMD_REQDESCRIPTION format:
	 *
	 *	obj_num
	 */
	sscanf(
	    arg,
	    "%i",
	    &obj_num
	);

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	NetSendObjectDescription(condescriptor, obj_num);

	return(0);
}


int NetSendObjectDescription(int condescriptor, int obj_num)
{
	char	desc[CS_DATA_MAX_LEN - 40],
		sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *obj;

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];
	if(obj->description == NULL)
	    return(0);

	strncpy(desc, obj->description, sizeof(desc));
	desc[sizeof(desc) - 1] = '\0';

	/* SWEXTCMD_SETDESCRIPTION format:
	 *
	 *	obj_num;description
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i;%s\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETDESCRIPTION,
	    obj_num,
	    desc
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
