#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleObjectName(int condescriptor, char *arg)
{
	int obj_num;

	/* SWEXTCMD_REQNAME format:
	 *
	 *	obj_num
	 */
	sscanf(
	    arg,
	    "%i",
	    &obj_num
	);

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	NetSendObjectName(condescriptor, obj_num);

	return(0);
}


int NetSendObjectName(int condescriptor, int obj_num)
{
	xsw_object_struct *obj;
	char sndbuf[CS_DATA_MAX_LEN];

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];

	/* SWEXTCMD_SETOBJNAME format:
	 *
	 *	obj_num;name;empire
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i;%s;%s\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETOBJNAME,
	    obj_num,
	    obj->name, obj->empire
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
