#include <stdio.h>
#include <stdlib.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleObjectValues(int condescriptor, char *arg);
int NetSendObjectValues(int condescriptor, int obj_num);


int NetHandleObjectValues(int condescriptor, char *arg)
{
	int obj_num, con_obj_num;
	int loc_type;        
	int locked_on;
	int intercepting_object;
	int thrust_rev_state;
	float thrust_dir;
	float thrust;
	float throttle;
	int lighting;		/* xswo_lighting_t */
	float hp;
	float power;
	float antimatter;
	int shield_state;
	int selected_weapon;
	int cloak_state;
	float cloak_strength;
	float visibility;
	int damage_control;
	xsw_object_struct *obj;

	con_obj_num = connection[condescriptor]->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return(-1);

	obj = xsw_object[con_obj_num];

	/* SWEXTCMD_STDOBJVALS format:
	 *
	 *	obj_num
	 *	loc_type locked_on intercepting_object
	 *	thrust_rev_state thrust_dir thrust throttle
	 *	lighting hp power
	 *	antimatter shield_state selected_weapon cloak_state
	 *	cloak_strength visibility damage_control
	 */
	sscanf(
	    arg,
"%i\
 %i %i %i\
 %i %f %f %f\
 %i %f %f\
 %f %i %i %i\
 %f %f %i",
	    &obj_num,
	    &loc_type, &locked_on, &intercepting_object,
	    &thrust_rev_state, &thrust_dir, &thrust, &throttle,
	    &lighting, &hp, &power,
	    &antimatter, &shield_state, &selected_weapon, &cloak_state,
	    &cloak_strength, &visibility, &damage_control
	);

	/* Connection must own object */
	if(obj_num != con_obj_num)
	    return(-3);

	/* Set throttle */
	if(throttle < 0.0f)
	    throttle = 0.0f;
	else if(throttle > 1.0f)
	    throttle = 1.0f;
	obj->throttle = throttle;

	/* All other members are not set from client */

	return(0);
}


int NetSendObjectValues(int condescriptor, int obj_num)
{
	xsw_object_struct *obj;
	char sndbuf[CS_DATA_MAX_LEN];

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];

	/* SWEXTCMD_STDOBJVALS format:
	 *
	 *	obj_num
	 *	loc_type locked_on intercepting_object
	 *	thrust_rev_state thrust_dir thrust throttle
	 *	lighting hp power
	 *	antimatter shield_state selected_weapon cloak_state
	 *	cloak_strength visibility damage_control
	 */
	sprintf(
	    sndbuf,
"%i %i %i\
 %i %i %i\
 %i %.4f %.5f %.4f\
 %lu %.4f %.4f\
 %.4f %i %i\
 %i %.4f %.4f %i\n",
	    CS_CODE_EXT,
	    SWEXTCMD_STDOBJVALS,
	    obj_num,
	    obj->loc_type, obj->locked_on, obj->intercepting_object,
	    0,		/* thrust_rev_state, no longer used */
	    obj->thrust_dir, obj->thrust, obj->throttle,
	    (unsigned long)obj->lighting, obj->hp, obj->power,
	    obj->antimatter, obj->shield_state, obj->selected_weapon,
	    obj->cloak_state, obj->cloak_strength, obj->visibility, obj->damage_control
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
