#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleScore(int condescriptor, char *arg)
{
	int obj_num;

	/* SWEXTCMD_SETSCORE format:
	 *
	 *	obj_num
	 */
	sscanf(
	    arg,
	    "%i",
	    &obj_num
	);

	NetSendScore(condescriptor, obj_num);

	return(0);
}


int NetSendScore(int condescriptor, int obj_num)
{
	char sndbuf[CS_DATA_MAX_LEN];
	xsw_object_struct *obj;
	xsw_score_struct *score;

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];
	score = obj->score;
	if(score == NULL)
	    return(0);

	/* SWEXTCMD_SETSCORE format:
	 *
	 *	obj_num 
	 *	credits rmu rmu_max
	 *	damage_given damage_recieved kills
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %.2f %.2f %.2f %.2f %.2f %i\n",
	    CS_CODE_EXT,
	    SWEXTCMD_SETSCORE,
	    obj_num,
	    score->credits, score->rmu, score->rmu_max,
	    score->damage_given, score->damage_recieved, score->kills
	);
	NetDoSend(condescriptor, sndbuf);

	return(0);
}
