#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleSetShields(int condescriptor, char *arg)
{
	int shield_state, obj_num, con_obj_num;
	double shield_frequency;
	xsw_object_struct *obj;

	con_obj_num = connection[condescriptor]->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return(-1);

	obj = xsw_object[con_obj_num];

	/* NET_CMD_SETSHIELDS format:
	 *
	 *	obj_num shield_state shield_frequency
	 */
	sscanf(
	    arg,
	    "%i %i %lf",
	    &obj_num, &shield_state, &shield_frequency
	);

	/* Connection must own object */
	if(obj_num != con_obj_num)
	    return(-3);

	/* Does object have shields generators? */
	if(obj->shield_state == SHIELD_STATE_NONE)
	    return(1);

	/* Set shield_frequency */
	if(shield_frequency > SW_FREQ_MAX)
	    shield_frequency = SW_FREQ_MAX;
	else if(shield_frequency < SW_FREQ_MIN)
	    shield_frequency = SW_FREQ_MIN;

	obj->shield_frequency = shield_frequency;


	/* Is the cloak up? */
	if(obj->cloak_state == CLOAK_STATE_UP)
	{ 
	    obj->shield_state = SHIELD_STATE_DOWN;
	    return(1);
	}


	/* Set shield visibility if shield is just raised */
	if((obj->shield_state == SHIELD_STATE_DOWN) &&
	   (obj->power_max > 0) &&
	   (shield_state == SHIELD_STATE_UP)
	)
	{
	    obj->shield_visibility = 
		obj->power / obj->power_max;

	    /* Send shield visibility to all connections */
	    NetSendShieldVis(-1, obj_num);
	}

	obj->shield_state = shield_state;

	/* Set next object values update to now, so it gets updated now */
	next.object_values = cur_millitime;

	return(0);
}


int NetSendSetShields(int condescriptor, int obj_num)
{

	return(0);
}
