#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleObjectThrottle(int condescriptor, char *arg)
{
	int obj_num, con_obj_num;
	float throttle;
	xsw_object_struct *obj;

	con_obj_num = connection[condescriptor]->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return(-1);

	obj = xsw_object[con_obj_num];

	/* SWEXTCMD_SETTHROTTLE format:
	 *
	 *      obj_num throttle
	 */
	sscanf(
	    arg,
	    "%i %f",
	    &obj_num, &throttle   
	);

	/* Connection must own object */
	if(obj_num != con_obj_num)
	    return(-3);

	/* Sanitize throttle value */
	if(throttle < 0.0)
	    throttle = 0.0;
	else if(throttle > 1.0)
	    throttle = 1.0;
	
	/* Set throttle value */
	obj->throttle = throttle;

	return(0);
}


int NetSendObjectThrottle(int condescriptor)
{

	return(0);
}
