#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h"


int NetHandleSelectWeapon(int condescriptor, char *arg)
{
	int obj_num, con_obj_num, sel_wep_num;
	xsw_object_struct *obj;

	con_obj_num = connection[condescriptor]->object_num;
	if(DBIsObjectGarbage(con_obj_num))
	    return(-1);

	obj = xsw_object[con_obj_num];

	/* SWEXTCMD_SETWEAPON format:
	 *
	 *	obj_num sel_wep_num
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &sel_wep_num
	);

	/* Can only set the connection's object */
	if(obj_num != con_obj_num)
	    return(-3);

	/* Make sure sel_wep_num is valid */
	if((sel_wep_num < 0) || (sel_wep_num >= SW_OBJ_WEAPONS_MAX))
	    return(-1);
	if(sel_wep_num >= obj->total_weapons)
	    return(-1);

	/* Set selected weapon */
	obj->selected_weapon = sel_wep_num;

	/* Set next object values update to now so it gets updated now */
	next.object_values = cur_millitime;

	return(0);
}


int NetSendSelectWeapon(int condescriptor)
{
	return(0);
}
