#include <stdio.h>

#include "../include/unvmatch.h"
#include "../include/swnetcodes.h"

#include "net.h"
#include "swserv.h" 


int NetHandleWeaponValues(int condescriptor, char *arg)
{
	int obj_num, wep_num;

	/* SWEXTCMD_STDWEPVALS format:
	 *
	 *      obj_num wep_num
	 */
	sscanf(
	    arg,
	    "%i %i",
	    &obj_num, &wep_num
	);

	NetSendWeaponValues(condescriptor, obj_num, wep_num);

	return(0);
}
 
 
int NetSendWeaponValues(
	int condescriptor, int obj_num, int wep_num
)
{
	xsw_object_struct *obj;
	xsw_weapon_struct *wep;
	char sndbuf[CS_DATA_MAX_LEN];

	if(DBIsObjectGarbage(obj_num))
	    return(-1);

	obj = xsw_object[obj_num];

	wep = ((wep_num >= 0) && (wep_num < obj->total_weapons)) ?
	    obj->weapons[wep_num] : NULL;
	if(wep == NULL)
	    return(-1);

	/* SWEXTCMD_STDWEPVALS format:
	 *
	 *	obj_num wep_num
	 *	ocs_code emission_type amount max
	 *	power range create_power
	 *	delay last_used fire_sndref flags
	 */
	sprintf(
	    sndbuf,
"%i %i\
 %i %i\
 %i %i %i %i\
 %.4f %ld %.4f\
 %ld %ld %i %lu\n",
	    CS_CODE_EXT,
	    SWEXTCMD_STDWEPVALS,
	    obj_num, wep_num,
	    wep->ocs_code, wep->emission_type, wep->amount, wep->max,
	    wep->power, wep->range, wep->create_power,
	    wep->delay, wep->last_used, wep->fire_sound_code,
	    (unsigned long)wep->flags
	);

	NetDoSend(condescriptor, sndbuf);

	return(0);
}
