#include <stdio.h>
#include <stdlib.h>

#include "../include/unvfile.h"

#include "sysparm.h"
#include "swserv.h"


int OPMFileOpen(const char *path);


/*
 *	Loads object parameter models from the specified file.
 */
int OPMFileOpen(const char *path)
{
	int total;
	sws_std_opm_struct *opm_ref = &sws_std_opm;

	/* Delete all existing OPMs */
	OPMDeleteAll();

	/* Load objects from file */
	total = total_opms;
	opm = UNVFileOpen(
	    path,
	    &total,
	    NULL,
	    NULL,	/* Client data */
	    NULL	/* Notify callback function */
	);
	total_opms = total;

	/* Get references to standard OPMs */
	opm_ref->explosion_small_num = OPMGetByName(
	    "Explosion1", -1
	);
	if(opm_ref->explosion_small_num < 0)
	    fprintf(
		stderr,
"%s: Standard OPM `%s' not defined.\n",
		path, "Explosion1"
	    );
	opm_ref->explosion_large_num = OPMGetByName(
	    "Explosion3", -1
	);
	if(opm_ref->explosion_large_num < 0)
	    fprintf(
		stderr,
"%s: Standard OPM `%s' not defined.\n",
		path, "Explosion3"
	    );
	opm_ref->debris_num = OPMGetByName( 
	    SWS_DEF_DEBRIS_OPM_NAME, -1
	);
	if(opm_ref->debris_num < 0)
	    fprintf(
		stderr,
"%s: Standard OPM `%s' not defined.\n",
		path, SWS_DEF_DEBRIS_OPM_NAME
	    );
	opm_ref->guest_num = OPMGetByName( 
	    sysparm.guest_login_name, SW_OBJ_TYPE_PLAYER
	);
	if(opm_ref->guest_num < 0)
	    fprintf(
		stderr,
"%s: OPM `%s' not defined.\n",
		path, sysparm.guest_login_name
	    );
	opm_ref->new_player_num = OPMGetByName( 
	    SWS_DEF_NEW_PLAYER_OPM_NAME, SW_OBJ_TYPE_PLAYER
	);
	if(opm_ref->new_player_num < 0)
	    fprintf(
		stderr,
"%s: Standard OPM `%s' not defined.\n",
		path, SWS_DEF_NEW_PLAYER_OPM_NAME
	    );

	return(0);
}
